##// END OF EJS Templates
always include locales ...
Unknown -
r374:e02b3a1b7b3b
parent child
Show More
@@ -1,797 +1,796
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 20+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ -n "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45
46 46 #bcm2708-rpi-0-w.dtb (Used for Pi 0 and PI 0W)
47 47 RPI0_DTB_FILE=${RPI0_DTB_FILE:=bcm2708-rpi-0-w.dtb}
48 48 RPI0_UBOOT_CONFIG=${RPI0_UBOOT_CONFIG:=rpi_defconfig}
49 49
50 50 #bcm2708-rpi-b.dtb (Used for Pi 1 model A and B)
51 51 RPI1_DTB_FILE=${RPI1_DTB_FILE:=bcm2708-rpi-b.dtb}
52 52 RPI1_UBOOT_CONFIG=${RPI1_UBOOT_CONFIG:=rpi_defconfig}
53 53
54 54 #bcm2708-rpi-b-plus.dtb (Used for Pi 1 model B+ and A+)
55 55 RPI1P_DTB_FILE=${RPI1P_DTB_FILE:=bcm2708-rpi-b-plus.dtb}
56 56 RPI1P_UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG:=rpi_defconfig}
57 57
58 58 #bcm2709-rpi-2-b.dtb (Used for Pi 2 model B)
59 59 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
60 60 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
61 61
62 62 #bcm2710-rpi-3-b.dtb (Used for Pi 3 model B)
63 63 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
64 64 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
65 65
66 66 #bcm2710-rpi-3-b-plus.dtb (Used for Pi 3 model B+)
67 67 RPI3P_DTB_FILE=${RPI3P_DTB_FILE:=bcm2710-rpi-3-b-plus.dtb}
68 68 RPI3P_UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG:=rpi_3_32b_defconfig}
69 69
70 70 # Debian release
71 71 RELEASE=${RELEASE:=jessie}
72 72 KERNEL_ARCH=${KERNEL_ARCH:=arm}
73 73 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
74 74 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
75 75 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
76 76 if [ "$KERNEL_ARCH" = "arm64" ] ; then
77 77 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
78 78 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
79 79 fi
80 80
81 81 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
82 82 #RASPBERRY PI 1, PI ZERO, PI ZERO W, AND COMPUTE MODULE DEFAULT Kernel BUILD CONFIGURATION
83 83 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
84 84 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
85 85 else
86 86 #RASPBERRY PI 2, PI 3, PI 3+, AND COMPUTE MODULE 3 DEFAULT Kernel BUILD CONFIGURATION
87 87 #https://www.raspberrypi.org/documentation/linux/kernel/building.md
88 88 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
89 89 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
90 90 fi
91 91
92 92 if [ "$RELEASE_ARCH" = "arm64" ] ; then
93 93 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
94 94 else
95 95 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
96 96 fi
97 97 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
98 98
99 99 # URLs
100 100 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
101 101 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
102 102 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
103 103 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
104 104 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
105 105 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
106 106 VIDEOCORE_URL=${VIDEOCORE_URL=https://github.com/raspberrypi/userland}
107 107 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
108 108
109 109 # Build directories
110 110 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
111 111 BUILDDIR="${BASEDIR}/build"
112 112
113 113 # Prepare date string for default image file name
114 114 DATE="$(date +%Y-%m-%d)"
115 115 if [ -z "$KERNEL_BRANCH" ] ; then
116 116 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
117 117 else
118 118 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
119 119 fi
120 120
121 121 # Chroot directories
122 122 R="${BUILDDIR}/chroot"
123 123 ETC_DIR="${R}/etc"
124 124 LIB_DIR="${R}/lib"
125 125 BOOT_DIR="${R}/boot/firmware"
126 126 KERNEL_DIR="${R}/usr/src/linux"
127 127 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
128 128
129 129 # Firmware directory: Blank if download from github
130 130 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
131 131
132 132 # General settings
133 133 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
134 134 PASSWORD=${PASSWORD:=raspberry}
135 135 USER_PASSWORD=${USER_PASSWORD:=raspberry}
136 136 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
137 137 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
138 138 EXPANDROOT=${EXPANDROOT:=true}
139 139
140 140 # Keyboard settings
141 141 XKB_MODEL=${XKB_MODEL:=""}
142 142 XKB_LAYOUT=${XKB_LAYOUT:=""}
143 143 XKB_VARIANT=${XKB_VARIANT:=""}
144 144 XKB_OPTIONS=${XKB_OPTIONS:=""}
145 145
146 146 # Network settings (DHCP)
147 147 ENABLE_DHCP=${ENABLE_DHCP:=true}
148 148
149 149 # Network settings (static)
150 150 NET_ADDRESS=${NET_ADDRESS:=""}
151 151 NET_GATEWAY=${NET_GATEWAY:=""}
152 152 NET_DNS_1=${NET_DNS_1:=""}
153 153 NET_DNS_2=${NET_DNS_2:=""}
154 154 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
155 155 NET_NTP_1=${NET_NTP_1:=""}
156 156 NET_NTP_2=${NET_NTP_2:=""}
157 157
158 158 # APT settings
159 159 APT_PROXY=${APT_PROXY:=""}
160 160 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
161 161
162 162 # Feature settings
163 163 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
164 164 ENABLE_I2C=${ENABLE_I2C:=false}
165 165 ENABLE_SPI=${ENABLE_SPI:=false}
166 166 ENABLE_IPV6=${ENABLE_IPV6:=true}
167 167 ENABLE_SSHD=${ENABLE_SSHD:=true}
168 168 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
169 169 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
170 170 ENABLE_SOUND=${ENABLE_SOUND:=true}
171 171 ENABLE_DBUS=${ENABLE_DBUS:=true}
172 172 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
173 173 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
174 174 ENABLE_XORG=${ENABLE_XORG:=false}
175 175 ENABLE_WM=${ENABLE_WM:=""}
176 176 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
177 177 ENABLE_USER=${ENABLE_USER:=true}
178 178 USER_NAME=${USER_NAME:="pi"}
179 179 ENABLE_ROOT=${ENABLE_ROOT:=false}
180 180 ENABLE_QEMU=${ENABLE_QEMU:=false}
181 181 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
182 182
183 183 # SSH settings
184 184 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
185 185 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
186 186 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
187 187 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
188 188 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
189 189
190 190 # Advanced settings
191 191 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
192 192 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
193 193 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
194 194 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
195 195 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
196 196 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=true}
197 197 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
198 198 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
199 199 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
200 200 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
201 201 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
202 202 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
203 203 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
204 204 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
205 205
206 206 # Kernel compilation settings
207 207 BUILD_KERNEL=${BUILD_KERNEL:=false}
208 208 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
209 209 KERNEL_THREADS=${KERNEL_THREADS:=1}
210 210 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
211 211 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
212 212 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
213 213 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
214 214 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
215 215
216 216 if [ "$KERNEL_ARCH" = "arm64" ] ; then
217 217 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
218 218 else
219 219 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
220 220 fi
221 221
222 222 # Kernel compilation from source directory settings
223 223 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
224 224 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
225 225 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
226 226 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
227 227
228 228 # Reduce disk usage settings
229 229 REDUCE_APT=${REDUCE_APT:=true}
230 230 REDUCE_DOC=${REDUCE_DOC:=true}
231 231 REDUCE_MAN=${REDUCE_MAN:=true}
232 232 REDUCE_VIM=${REDUCE_VIM:=false}
233 233 REDUCE_BASH=${REDUCE_BASH:=false}
234 234 REDUCE_HWDB=${REDUCE_HWDB:=true}
235 235 REDUCE_SSHD=${REDUCE_SSHD:=true}
236 236 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
237 237
238 238 # Encrypted filesystem settings
239 239 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
240 240 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
241 241 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
242 242 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
243 243 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
244 244
245 245 # Chroot scripts directory
246 246 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
247 247
248 248 # Packages required in the chroot build environment
249 249 APT_INCLUDES=${APT_INCLUDES:=""}
250 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
250 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup"
251 251
252 252 #Packages to exclude from chroot build environment
253 253 APT_EXCLUDES=${APT_EXCLUDES:=""}
254 254
255 255 # Packages required for bootstrapping
256 256 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
257 257 MISSING_PACKAGES=""
258 258
259 259 # Packages installed for c/c++ build environment in chroot (keep empty)
260 260 COMPILER_PACKAGES=""
261 261
262 262 set +x
263 263
264 264 #If init and systemd-sysv are wanted e.g. halt/reboot/shutdown scripts
265 265 if [ "$ENABLE_SYSVINIT" = false ] ; then
266 266 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
267 267 fi
268 268
269 #Check if apt-cacher-ng has its default port open on and set APT_PROXY
270 if [ -n "$(lsof -i :3142)" ] ; then
271 HTTP_PROXY=http://127.0.0.1:3142/
272
269 273 # Set Raspberry Pi model specific configuration
270 274 if [ "$RPI_MODEL" = 0 ] ; then
271 275 DTB_FILE=${RPI0_DTB_FILE}
272 276 UBOOT_CONFIG=${RPI0_UBOOT_CONFIG}
273 277 elif [ "$RPI_MODEL" = 1 ] ; then
274 278 DTB_FILE=${RPI1_DTB_FILE}
275 279 UBOOT_CONFIG=${RPI1_UBOOT_CONFIG}
276 280 elif [ "$RPI_MODEL" = 1P ] ; then
277 281 DTB_FILE=${RPI1P_DTB_FILE}
278 282 UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG}
279 283 elif [ "$RPI_MODEL" = 2 ] ; then
280 284 DTB_FILE=${RPI2_DTB_FILE}
281 285 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
282 286 elif [ "$RPI_MODEL" = 3 ] ; then
283 287 DTB_FILE=${RPI3_DTB_FILE}
284 288 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
285 289 elif [ "$RPI_MODEL" = 3P ] ; then
286 290 DTB_FILE=${RPI3P_DTB_FILE}
287 291 UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG}
288 292 else
289 293 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
290 294 exit 1
291 295 fi
292 296
293 297 # Check if the internal wireless interface is supported by the RPi model
294 298 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]); then
295 299
296 300 echo "error: The selected Raspberry Pi model has no internal wireless interface"
297 301 exit 1
298 302 fi
299 303
300 304 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
301 305 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
302 306 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
303 307 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
304 308 exit 1
305 309 fi
306 310 fi
307 311
308 312 # Build RPi2/3 Linux kernel if required by Debian release
309 313 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
310 314 BUILD_KERNEL=true
311 315 fi
312 316
313 317 # Add packages required for kernel cross compilation
314 318 if [ "$BUILD_KERNEL" = true ] ; then
315 319 if [ "$KERNEL_ARCH" = "arm" ] ; then
316 320 if [ "$RELEASE_ARCH" = "armel" ]; then
317 321 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
318 322 fi
319 323 if [ "$RELEASE_ARCH" = "armhf" ]; then
320 324 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
321 325 fi
322 326 fi
323 327 if [ "$RELEASE_ARCH" = "arm64" ]; then
324 328 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
325 329 fi
326 330 fi
327 331
328 332 if [ "$ENABLE_VIDEOCORE" = true ] ; then
329 333 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
330 334 fi
331 335
332 336 # Add libncurses5 to enable kernel menuconfig
333 337 if [ "$KERNEL_MENUCONFIG" = true ] ; then
334 338 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
335 339 fi
336 340
337 341 # Add ccache compiler cache for (faster) kernel cross (re)compilation
338 342 if [ "$KERNEL_CCACHE" = true ] ; then
339 343 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
340 344 fi
341 345
342 346 # Add cryptsetup package to enable filesystem encryption
343 347 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
344 348 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
345 349 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
346 350
347 351 if [ -z "$CRYPTFS_PASSWORD" ] ; then
348 352 echo "error: no password defined (CRYPTFS_PASSWORD)!"
349 353 exit 1
350 354 fi
351 355 ENABLE_INITRAMFS=true
352 356 fi
353 357
354 358 # Add initramfs generation tools
355 359 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
356 360 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
357 361 fi
358 362
359 363 # Add device-tree-compiler required for building the U-Boot bootloader
360 364 if [ "$ENABLE_UBOOT" = true ] ; then
361 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
365 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
362 366 fi
363 367
364 368 # Check if root SSH (v2) public key file exists
365 369 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
366 370 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
367 371 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
368 372 exit 1
369 373 fi
370 374 fi
371 375
372 376 # Check if $USER_NAME SSH (v2) public key file exists
373 377 if [ -n "$SSH_USER_PUB_KEY" ] ; then
374 378 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
375 379 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
376 380 exit 1
377 381 fi
378 382 fi
379 383
380 384 # Check if all required packages are installed on the build system
381 385 for package in $REQUIRED_PACKAGES ; do
382 386 if [ "$(dpkg-query -W -f='${Status}' $package)" != "install ok installed" ] ; then
383 387 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
384 388 fi
385 389 done
386 390
387 391 # If there are missing packages ask confirmation for install, or exit
388 392 if [ -n "$MISSING_PACKAGES" ] ; then
389 393 echo "the following packages needed by this script are not installed:"
390 394 echo "$MISSING_PACKAGES"
391 395
392 396 printf "\ndo you want to install the missing packages right now? [y/n] "
393 397 read -r confirm
394 398 [ "$confirm" != "y" ] && exit 1
395 399
396 400 # Make sure all missing required packages are installed
397 401 apt-get -qq -y install "${MISSING_PACKAGES}"
398 402 fi
399 403
400 404 # Check if ./bootstrap.d directory exists
401 405 if [ ! -d "./bootstrap.d/" ] ; then
402 406 echo "error: './bootstrap.d' required directory not found!"
403 407 exit 1
404 408 fi
405 409
406 410 # Check if ./files directory exists
407 411 if [ ! -d "./files/" ] ; then
408 412 echo "error: './files' required directory not found!"
409 413 exit 1
410 414 fi
411 415
412 416 # Check if specified KERNELSRC_DIR directory exists
413 417 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
414 418 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
415 419 exit 1
416 420 fi
417 421
418 422 # Check if specified UBOOTSRC_DIR directory exists
419 423 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
420 424 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
421 425 exit 1
422 426 fi
423 427
424 428 # Check if specified VIDEOCORESRC_DIR directory exists
425 429 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
426 430 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
427 431 exit 1
428 432 fi
429 433
430 434 # Check if specified FBTURBOSRC_DIR directory exists
431 435 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
432 436 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
433 437 exit 1
434 438 fi
435 439
436 440 # Check if specified CHROOT_SCRIPTS directory exists
437 441 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
438 442 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
439 443 exit 1
440 444 fi
441 445
442 446 # Check if specified device mapping already exists (will be used by cryptsetup)
443 447 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
444 448 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
445 449 exit 1
446 450 fi
447 451
448 452 # Don't clobber an old build
449 453 if [ -e "$BUILDDIR" ] ; then
450 454 echo "error: directory ${BUILDDIR} already exists, not proceeding"
451 455 exit 1
452 456 fi
453 457
454 458 # Setup chroot directory
455 459 mkdir -p "${R}"
456 460
457 461 # Check if build directory has enough of free disk space >512MB
458 462 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
459 463 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
460 464 exit 1
461 465 fi
462 466
463 467 set -x
464 468
465 469 # Call "cleanup" function on various signals and errors
466 470 trap cleanup 0 1 2 3 6
467 471
468 472 # Add required packages for the minbase installation
469 473 if [ "$ENABLE_MINBASE" = true ] ; then
470 474 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
471 475 fi
472 476
473 # Add required locales packages
474 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
475 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
476 fi
477
478 477 # Add parted package, required to get partprobe utility
479 478 if [ "$EXPANDROOT" = true ] ; then
480 479 APT_INCLUDES="${APT_INCLUDES},parted"
481 480 fi
482 481
483 482 # Add dbus package, recommended if using systemd
484 483 if [ "$ENABLE_DBUS" = true ] ; then
485 484 APT_INCLUDES="${APT_INCLUDES},dbus"
486 485 fi
487 486
488 487 # Add iptables IPv4/IPv6 package
489 488 if [ "$ENABLE_IPTABLES" = true ] ; then
490 489 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
491 490 fi
492 491
493 492 # Add openssh server package
494 493 if [ "$ENABLE_SSHD" = true ] ; then
495 494 APT_INCLUDES="${APT_INCLUDES},openssh-server"
496 495 fi
497 496
498 497 # Add alsa-utils package
499 498 if [ "$ENABLE_SOUND" = true ] ; then
500 499 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
501 500 fi
502 501
503 502 # Add rng-tools package
504 503 if [ "$ENABLE_HWRANDOM" = true ] ; then
505 504 APT_INCLUDES="${APT_INCLUDES},rng-tools"
506 505 fi
507 506
508 507 # Add fbturbo video driver
509 508 if [ "$ENABLE_FBTURBO" = true ] ; then
510 509 # Enable xorg package dependencies
511 510 ENABLE_XORG=true
512 511 fi
513 512
514 513 # Add user defined window manager package
515 514 if [ -n "$ENABLE_WM" ] ; then
516 515 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
517 516
518 517 # Enable xorg package dependencies
519 518 ENABLE_XORG=true
520 519 fi
521 520
522 521 # Add xorg package
523 522 if [ "$ENABLE_XORG" = true ] ; then
524 523 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
525 524 fi
526 525
527 526 # Replace selected packages with smaller clones
528 527 if [ "$ENABLE_REDUCE" = true ] ; then
529 528 # Add levee package instead of vim-tiny
530 529 if [ "$REDUCE_VIM" = true ] ; then
531 530 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
532 531 fi
533 532
534 533 # Add dropbear package instead of openssh-server
535 534 if [ "$REDUCE_SSHD" = true ] ; then
536 535 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
537 536 fi
538 537 fi
539 538
540 539 if [ "$RELEASE" != "jessie" ] ; then
541 540 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
542 541 fi
543 542
544 543 # Configure kernel sources if no KERNELSRC_DIR
545 544 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
546 545 KERNELSRC_CONFIG=true
547 546 fi
548 547
549 548 # Configure reduced kernel
550 549 if [ "$KERNEL_REDUCE" = true ] ; then
551 550 KERNELSRC_CONFIG=false
552 551 fi
553 552
554 553 # Configure qemu compatible kernel
555 554 if [ "$ENABLE_QEMU" = true ] ; then
556 555 DTB_FILE=vexpress-v2p-ca15_a7.dtb
557 556 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
558 557 KERNEL_DEFCONFIG="vexpress_defconfig"
559 558 if [ "$KERNEL_MENUCONFIG" = false ] ; then
560 559 KERNEL_OLDDEFCONFIG=true
561 560 fi
562 561 fi
563 562
564 563 # Execute bootstrap scripts
565 564 for SCRIPT in bootstrap.d/*.sh; do
566 565 head -n 3 "$SCRIPT"
567 566 . "$SCRIPT"
568 567 done
569 568
570 569 ## Execute custom bootstrap scripts
571 570 if [ -d "custom.d" ] ; then
572 571 for SCRIPT in custom.d/*.sh; do
573 572 . "$SCRIPT"
574 573 done
575 574 fi
576 575
577 576 # Execute custom scripts inside the chroot
578 577 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
579 578 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
580 579 chroot_exec /bin/bash -x <<'EOF'
581 580 for SCRIPT in /chroot_scripts/* ; do
582 581 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
583 582 $SCRIPT
584 583 fi
585 584 done
586 585 EOF
587 586 rm -rf "${R}/chroot_scripts"
588 587 fi
589 588
590 589 # Remove c/c++ build environment from the chroot
591 590 chroot_remove_cc
592 591
593 592 # Remove apt-utils
594 593 if [ "$RELEASE" = "jessie" ] ; then
595 594 chroot_exec apt-get purge -qq -y --force-yes apt-utils
596 595 fi
597 596
598 597 # Generate required machine-id
599 598 MACHINE_ID=$(dbus-uuidgen)
600 599 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
601 600 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
602 601
603 602 # APT Cleanup
604 603 chroot_exec apt-get -y clean
605 604 chroot_exec apt-get -y autoclean
606 605 chroot_exec apt-get -y autoremove
607 606
608 607 # Unmount mounted filesystems
609 608 umount -l "${R}/proc"
610 609 umount -l "${R}/sys"
611 610
612 611 # Clean up directories
613 612 rm -rf "${R}/run/*"
614 613 rm -rf "${R}/tmp/*"
615 614
616 615 # Clean up files
617 616 rm -f "${ETC_DIR}/ssh/ssh_host_*"
618 617 rm -f "${ETC_DIR}/dropbear/dropbear_*"
619 618 rm -f "${ETC_DIR}/apt/sources.list.save"
620 619 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
621 620 rm -f "${ETC_DIR}/*-"
622 621 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
623 622 rm -f "${ETC_DIR}/resolv.conf"
624 623 rm -f "${R}/root/.bash_history"
625 624 rm -f "${R}/var/lib/urandom/random-seed"
626 625 rm -f "${R}/initrd.img"
627 626 rm -f "${R}/vmlinuz"
628 627 rm -f "${R}${QEMU_BINARY}"
629 628
630 629 if [ "$ENABLE_QEMU" = true ] ; then
631 630 # Setup QEMU directory
632 631 mkdir "${BASEDIR}/qemu"
633 632
634 633 # Copy kernel image to QEMU directory
635 634 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
636 635
637 636 # Copy kernel config to QEMU directory
638 637 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
639 638
640 639 # Copy kernel dtbs to QEMU directory
641 640 for dtb in "${BOOT_DIR}/"*.dtb ; do
642 641 if [ -f "${dtb}" ] ; then
643 642 install_readonly "${dtb}" "${BASEDIR}/qemu/"
644 643 fi
645 644 done
646 645
647 646 # Copy kernel overlays to QEMU directory
648 647 if [ -d "${BOOT_DIR}/overlays" ] ; then
649 648 # Setup overlays dtbs directory
650 649 mkdir "${BASEDIR}/qemu/overlays"
651 650
652 651 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
653 652 if [ -f "${dtb}" ] ; then
654 653 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
655 654 fi
656 655 done
657 656 fi
658 657
659 658 # Copy u-boot files to QEMU directory
660 659 if [ "$ENABLE_UBOOT" = true ] ; then
661 660 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
662 661 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
663 662 fi
664 663 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
665 664 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
666 665 fi
667 666 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
668 667 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
669 668 fi
670 669 fi
671 670
672 671 # Copy initramfs to QEMU directory
673 672 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
674 673 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
675 674 fi
676 675 fi
677 676
678 677 # Calculate size of the chroot directory in KB
679 678 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
680 679
681 680 # Calculate the amount of needed 512 Byte sectors
682 681 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
683 682 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
684 683 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
685 684
686 685 # The root partition is EXT4
687 686 # This means more space than the actual used space of the chroot is used.
688 687 # As overhead for journaling and reserved blocks 35% are added.
689 688 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
690 689
691 690 # Calculate required image size in 512 Byte sectors
692 691 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
693 692
694 693 # Prepare image file
695 694 if [ "$ENABLE_SPLITFS" = true ] ; then
696 695 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
697 696 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
698 697 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
699 698 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
700 699
701 700 # Write firmware/boot partition tables
702 701 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
703 702 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
704 703 EOM
705 704
706 705 # Write root partition table
707 706 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
708 707 ${TABLE_SECTORS},${ROOT_SECTORS},83
709 708 EOM
710 709
711 710 # Setup temporary loop devices
712 711 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
713 712 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
714 713 else # ENABLE_SPLITFS=false
715 714 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
716 715 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
717 716
718 717 # Write partition table
719 718 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
720 719 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
721 720 ${ROOT_OFFSET},${ROOT_SECTORS},83
722 721 EOM
723 722
724 723 # Setup temporary loop devices
725 724 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
726 725 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
727 726 fi
728 727
729 728 if [ "$ENABLE_CRYPTFS" = true ] ; then
730 729 # Create dummy ext4 fs
731 730 mkfs.ext4 "$ROOT_LOOP"
732 731
733 732 # Setup password keyfile
734 733 touch .password
735 734 chmod 600 .password
736 735 echo -n ${CRYPTFS_PASSWORD} > .password
737 736
738 737 # Initialize encrypted partition
739 738 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
740 739
741 740 # Open encrypted partition and setup mapping
742 741 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
743 742
744 743 # Secure delete password keyfile
745 744 shred -zu .password
746 745
747 746 # Update temporary loop device
748 747 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
749 748
750 749 # Wipe encrypted partition (encryption cipher is used for randomness)
751 750 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
752 751 fi
753 752
754 753 # Build filesystems
755 754 mkfs.vfat "$FRMW_LOOP"
756 755 mkfs.ext4 "$ROOT_LOOP"
757 756
758 757 # Mount the temporary loop devices
759 758 mkdir -p "$BUILDDIR/mount"
760 759 mount "$ROOT_LOOP" "$BUILDDIR/mount"
761 760
762 761 mkdir -p "$BUILDDIR/mount/boot/firmware"
763 762 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
764 763
765 764 # Copy all files from the chroot to the loop device mount point directory
766 765 rsync -a "${R}/" "$BUILDDIR/mount/"
767 766
768 767 # Unmount all temporary loop devices and mount points
769 768 cleanup
770 769
771 770 # Create block map file(s) of image(s)
772 771 if [ "$ENABLE_SPLITFS" = true ] ; then
773 772 # Create block map files for "bmaptool"
774 773 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
775 774 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
776 775
777 776 # Image was successfully created
778 777 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
779 778 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
780 779 else
781 780 # Create block map file for "bmaptool"
782 781 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
783 782
784 783 # Image was successfully created
785 784 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
786 785
787 786 # Create qemu qcow2 image
788 787 if [ "$ENABLE_QEMU" = true ] ; then
789 788 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
790 789 QEMU_SIZE=16G
791 790
792 791 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
793 792 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
794 793
795 794 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
796 795 fi
797 796 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant